diff --git a/src/test/modules/Makefile b/src/test/modules/Makefile
index dffc79b2d9..5ccc82b4b5 100644
--- a/src/test/modules/Makefile
+++ b/src/test/modules/Makefile
@@ -27,6 +27,7 @@ SUBDIRS = \
 		  test_regex \
 		  test_rls_hooks \
 		  test_shm_mq \
+		  track_toast \
 		  unsafe_tests \
 		  worker_spi
 
diff --git a/src/test/modules/track_toast/.gitignore b/src/test/modules/track_toast/.gitignore
new file mode 100644
index 0000000000..5dcb3ff972
--- /dev/null
+++ b/src/test/modules/track_toast/.gitignore
@@ -0,0 +1,4 @@
+# Generated subdirectories
+/log/
+/results/
+/tmp_check/
diff --git a/src/test/modules/track_toast/Makefile b/src/test/modules/track_toast/Makefile
new file mode 100644
index 0000000000..26089b3deb
--- /dev/null
+++ b/src/test/modules/track_toast/Makefile
@@ -0,0 +1,18 @@
+# src/test/modules/track_toast/Makefile
+
+REGRESS = track_toast
+REGRESS_OPTS = --temp-config=$(top_srcdir)/src/test/modules/track_toast/track_toast.conf
+# Disabled because these tests require "track_toast = on",
+# which typical installcheck users do not have (e.g. buildfarm clients).
+NO_INSTALLCHECK = 1
+
+ifdef USE_PGXS
+PG_CONFIG = pg_config
+PGXS := $(shell $(PG_CONFIG) --pgxs)
+include $(PGXS)
+else
+subdir = src/test/modules/track_toast
+top_builddir = ../../../..
+include $(top_builddir)/src/Makefile.global
+include $(top_srcdir)/contrib/contrib-global.mk
+endif
diff --git a/src/test/modules/track_toast/expected/track_toast.out b/src/test/modules/track_toast/expected/track_toast.out
new file mode 100644
index 0000000000..39321f0340
--- /dev/null
+++ b/src/test/modules/track_toast/expected/track_toast.out
@@ -0,0 +1,6 @@
+SELECT 'TEST';
+ ?column? 
+----------
+ TEST
+(1 row)
+
diff --git a/src/test/modules/track_toast/sql/track_toast.sql b/src/test/modules/track_toast/sql/track_toast.sql
new file mode 100644
index 0000000000..a41415f61b
--- /dev/null
+++ b/src/test/modules/track_toast/sql/track_toast.sql
@@ -0,0 +1 @@
+SELECT 'TEST';
\ No newline at end of file
diff --git a/src/test/modules/track_toast/track_toast.conf b/src/test/modules/track_toast/track_toast.conf
new file mode 100644
index 0000000000..191f40a762
--- /dev/null
+++ b/src/test/modules/track_toast/track_toast.conf
@@ -0,0 +1 @@
+track_toast = on
\ No newline at end of file
